;; only currently for #+(and clisp mt)
(in-package :ap5)

(format t "reads should be allowed to interleave~%")
(loop for j below 4 do
  (let ((i j))
    (mt:make-thread
     (lambda ()
       (format t " start read ~a~%" i)
       (withreadaccess ;; outside timeout -- see sys-depend
        (mt:with-timeout
         ((+ 1 i) (format t " timeout read ~a~%" i))
         (loop for r s.t. (relationarity r i) do
           (format t " read ~a ~a~%" i r)
           (sleep (/ 1 (+ 1 i))))
         (format t " finish read ~a~%" i))))
     :name (format nil "read~a~%" i))))

(format t "writes should NOT be allowed to interleave~%")
(loop for j below 4 do
  (let ((i j))
    (mt:make-thread
     (lambda ()
       (withwriteaccess
        (format t " start write ~a~%" i)
        (mt:with-timeout
         ((+ 1 i) (format t " timeout write ~a~%" i))
         (sleep 2)
         (format t " finish write ~a~%" i))))
     :name (format nil "write~a~%" i))))
